<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/Primitives.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/Primitives.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 7 april 2009, 20:19</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef PRIMITIVES_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define PRIMITIVES_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Object.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstdint&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#define __STDC_FORMAT_MACROS</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#include &lt;cinttypes&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 SYLPH_BEGIN_NAMESPACE
<a name="l00030"></a>00030 SYLPH_PUBLIC
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 SYLPH_END_NAMESPACE
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byte;
<a name="l00035"></a>00035 <span class="keyword">typedef</span> int16_t sshort;
<a name="l00036"></a>00036 <span class="keyword">typedef</span> int32_t sint;
<a name="l00037"></a>00037 <span class="keyword">typedef</span> int64_t slong;
<a name="l00038"></a>00038 <span class="keyword">typedef</span> uint16_t sushort;
<a name="l00039"></a>00039 <span class="keyword">typedef</span> uint32_t suint;
<a name="l00040"></a>00040 <span class="keyword">typedef</span> uint64_t sulong;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#define S_FMT_S PRIi16</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#define S_FMT_US PRIu16</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#define S_FMT_I PRIi32</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#define S_FMT_UI PRIu32</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#define S_FMT_L PRIi64</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#define S_FMT_UL PRIu64</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 <span class="preprocessor">#define SIC(x) INT32_C(x)</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#define SUIC(x) UINT32_C(x)</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#define SLC(x) INT64_C(x)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#define SULC(x) UINT64_C(x)</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="preprocessor">#ifdef __i386__</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="keyword">typedef</span> suint idx_t;
<a name="l00057"></a>00057 <span class="keyword">typedef</span> sint sidx_t;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">typedef</span> suint ptr_t;
<a name="l00060"></a>00060 <span class="preprocessor">#elif defined(__x86_64__)</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="keyword">typedef</span> sulong idx_t;
<a name="l00062"></a>00062 <span class="keyword">typedef</span> slong sidx_t;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="keyword">typedef</span> sulong ptr_t;
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067 <span class="keyword">typedef</span> sulong fsize_t;
<a name="l00068"></a>00068 <span class="keyword">typedef</span> slong fssize_t;
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="namespacestd.html">00070</a> <span class="keyword">namespace </span>std {
<a name="l00071"></a>00071     using ::sidx_t;
<a name="l00072"></a>00072     using ::idx_t;
<a name="l00073"></a>00073     using ::fsize_t;
<a name="l00074"></a>00074     using ::fssize_t;
<a name="l00075"></a>00075     using ::ptr_t;
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="preprocessor">#ifndef SYLPH_LIKELY</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span><span class="preprocessor">    #if __GNUC__ - 0 &gt;= 3</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span><span class="preprocessor">        #define SYLPH_LIKELY(x) __builtin_expect(!!(x),1)</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span><span class="preprocessor">        #define SYLPH_UNLIKELY(x) __builtin_expect(!!(x),0)</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span><span class="preprocessor">    #else</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span><span class="preprocessor">        #define SYLPH_LIKELY(x) (x)</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span><span class="preprocessor">        #define SYLPH_UNLIKELY(x) (x)</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span><span class="preprocessor">    #endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="preprocessor">#define SYLPH_SPECIALIZE(Class,Type) extern template class Class&lt;Type&gt;</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>
<a name="l00091"></a>00091 <span class="preprocessor">#define SYLPH_SPECIALIZE_PRIMS(Class) \</span>
<a name="l00092"></a>00092 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,byte); \</span>
<a name="l00093"></a>00093 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,sint); \</span>
<a name="l00094"></a>00094 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,suint); \</span>
<a name="l00095"></a>00095 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,slong); \</span>
<a name="l00096"></a>00096 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,sulong); \</span>
<a name="l00097"></a>00097 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,bool); \</span>
<a name="l00098"></a>00098 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,float); \</span>
<a name="l00099"></a>00099 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,double); \</span>
<a name="l00100"></a>00100 <span class="preprocessor">    SYLPH_SPECIALIZE(Class,::Sylph::String)</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00102"></a>00102 <span class="comment">// Conversions ///////////////////////////////////////////////////////////////</span>
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 SYLPH_BEGIN_NAMESPACE
<a name="l00105"></a>00105 <span class="keyword">namespace </span>Convert {
<a name="l00106"></a>00106     <span class="keyword">inline</span> suint float2int(<span class="keywordtype">float</span> f) {
<a name="l00107"></a>00107         <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span>suint*<span class="keyword">&gt;</span>(&amp;f);
<a name="l00108"></a>00108     }
<a name="l00109"></a>00109     <span class="keyword">inline</span> <span class="keywordtype">float</span> int2float(suint i) {
<a name="l00110"></a>00110         <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">float</span>*<span class="keyword">&gt;</span>(&amp;i);
<a name="l00111"></a>00111     }
<a name="l00112"></a>00112     <span class="keyword">inline</span> sulong double2long(<span class="keywordtype">double</span> d) {
<a name="l00113"></a>00113         <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span>sulong*<span class="keyword">&gt;</span>(&amp;d);
<a name="l00114"></a>00114     }
<a name="l00115"></a>00115     <span class="keyword">inline</span> <span class="keywordtype">double</span> long2double(sulong l) {
<a name="l00116"></a>00116         <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">double</span>*<span class="keyword">&gt;</span>(&amp;l);
<a name="l00117"></a>00117     }
<a name="l00118"></a>00118     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;
<a name="l00119"></a>00119     <span class="keyword">inline</span> byte* a2bseq(<span class="keyword">const</span> T&amp; t) {
<a name="l00120"></a>00120         <span class="keywordflow">return</span> <span class="keyword">reinterpret_cast&lt;</span>byte*<span class="keyword">&gt;</span>(&amp;t);
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;
<a name="l00124"></a>00124     <span class="keyword">inline</span> byte* a2bseq(<span class="keyword">const</span> T* <span class="keyword">const</span> t) {
<a name="l00125"></a>00125         <span class="keywordflow">return</span> <span class="keyword">reinterpret_cast&lt;</span>byte*<span class="keyword">&gt;</span>(t);
<a name="l00126"></a>00126     }
<a name="l00127"></a>00127     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;
<a name="l00128"></a>00128     <span class="keyword">inline</span> T&amp; bseq2a(<span class="keyword">const</span> byte* b) {
<a name="l00129"></a>00129         <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span>T*<span class="keyword">&gt;</span>(b);
<a name="l00130"></a>00130     }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;
<a name="l00133"></a>00133     <span class="keyword">inline</span> ptr_t ptr2int(<span class="keyword">const</span> T* <span class="keyword">const</span> t) {
<a name="l00134"></a>00134         <span class="keywordflow">return</span> <span class="keyword">reinterpret_cast&lt;</span>ptr_t<span class="keyword">&gt;</span>(t);
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 SYLPH_END_NAMESPACE
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="preprocessor">#endif  </span><span class="comment">/* PRIMITIVES_H_ */</span>
<a name="l00140"></a>00140 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
